Name:		seabios
Version:        1.10.1
Release:	%mkrel 1
Summary:	Open-source legacy BIOS implementation

Group:		Emulators
License:	LGPLv3
URL:            http://www.coreboot.org/SeaBIOS
Source0:        http://code.coreboot.org/p/seabios/downloads/get/%{name}-%{version}.tar.gz

Source10:       config.vga.cirrus
Source11:       config.vga.isavga
Source12:       config.vga.qxl
Source13:       config.vga.stdvga
Source14:       config.vga.vmware
Source15:       config.csm
Source16:       config.coreboot
Source17:       config.seabios-128k
Source18:       config.seabios-256k
Source19:       config.vga.virtio

BuildRequires: python iasl
BuildRequires: binutils-x86_64-linux-gnu gcc-x86_64-linux-gnu

Requires: %{name}-bin = %{version}-%{release}
Requires: seavgabios-bin = %{version}-%{release}
Buildarch: noarch

# (tv) Building on ARM will fail due to missing cross-gcc:
ExclusiveArch:  x86_64

# Seabios is noarch, but required on architectures which cannot build it.
# Disable debuginfo because it is of no use to us.
%global debug_package %{nil}

# Similarly, tell RPM to not complain about x86 roms being shipped noarch
%global _binaries_in_noarch_packages_terminate_build   0


# You can build a debugging version of the BIOS by setting this to a
# value > 1.  See src/config.h for possible values, but setting it to
# a number like 99 will enable all possible debugging.  Note that
# debugging goes to a special qemu port that you have to enable.  See
# the SeaBIOS top-level README file for the magic qemu invocation to
# enable this.
%global debug_level 1

%description
SeaBIOS is an open-source legacy BIOS implementation which can be used as
a coreboot payload. It implements the standard BIOS calling interfaces
that a typical x86 proprietary BIOS implements.


%package bin
Summary: Seabios for x86
Buildarch: noarch

%description bin
SeaBIOS is an open-source legacy BIOS implementation which can be used as
a coreboot payload. It implements the standard BIOS calling interfaces
that a typical x86 proprietary BIOS implements.


%package -n seavgabios-bin
Summary: Seavgabios for x86
Buildarch: noarch
Obsoletes: vgabios

%description -n seavgabios-bin
SeaVGABIOS is an open-source VGABIOS implementation.


%prep
%setup -q


%build
export CFLAGS="$RPM_OPT_FLAGS"
mkdir binaries

build_bios() {
    make clean distclean
    cp $1 .config
    echo "CONFIG_DEBUG_LEVEL=%{debug_level}" >> .config
    make oldnoconfig V=1

    make V=1 \
        EXTRAVERSION="-%{release}" \
        HOSTCC=gcc \
        CC=x86_64-linux-gnu-gcc \
        AS=x86_64-linux-gnu-as \
        LD=x86_64-linux-gnu-ld \
        OBJCOPY=x86_64-linux-gnu-objcopy \
        OBJDUMP=x86_64-linux-gnu-objdump \
        STRIP=x86_64-linux-gnu-strip $4

    cp out/$2 binaries/$3
}

# seabios
build_bios %{_sourcedir}/config.seabios-128k bios.bin bios.bin
build_bios %{_sourcedir}/config.seabios-256k bios.bin bios-256k.bin
build_bios %{_sourcedir}/config.csm Csm16.bin bios-csm.bin
build_bios %{_sourcedir}/config.coreboot bios.bin.elf bios-coreboot.bin

# seavgabios
%global vgaconfigs cirrus isavga qxl stdvga vmware virtio
for config in %{vgaconfigs}; do
    build_bios %{_sourcedir}/config.vga.${config} \
               vgabios.bin vgabios-${config}.bin out/vgabios.bin
done


%install
mkdir -p $RPM_BUILD_ROOT%{_datadir}/seabios
mkdir -p $RPM_BUILD_ROOT%{_datadir}/seavgabios
install -m 0644 binaries/bios.bin $RPM_BUILD_ROOT%{_datadir}/seabios/bios.bin
install -m 0644 binaries/bios-256k.bin $RPM_BUILD_ROOT%{_datadir}/seabios/bios-256k.bin
install -m 0644 binaries/bios-csm.bin $RPM_BUILD_ROOT%{_datadir}/seabios/bios-csm.bin
install -m 0644 binaries/bios-coreboot.bin $RPM_BUILD_ROOT%{_datadir}/seabios/bios-coreboot.bin
install -m 0644 binaries/vgabios*.bin $RPM_BUILD_ROOT%{_datadir}/seavgabios

%files
%doc COPYING COPYING.LESSER README

%files bin
%dir %{_datadir}/seabios/
%{_datadir}/seabios/bios*.bin

%files -n seavgabios-bin
%dir %{_datadir}/seavgabios/
%{_datadir}/seavgabios/vgabios*.bin


%changelog
* Tue Dec 06 2016 tv <tv> 1.10.1-1.mga6
+ Revision: 1072785
- fix bs building a larger ROM
- drop merged patch
- force building on x86_64 host even if noarch due to missing cross-gcc on arm hosts
- new release

* Wed Aug 10 2016 tv <tv> 1.9.3-1.mga6
+ Revision: 1045447
- new release
- do not package config as it depends on the actual BIOS

* Tue Apr 26 2016 tv <tv> 1.9.1-3.mga6
+ Revision: 1006413
- alow debug versions of SeaBIOS to be built easily
- make it noarch
- pull VGA BIOS too
- no need to use exclusiveArch, we use cross toolchain

* Sat Apr 16 2016 tv <tv> 1.9.1-2.mga6
+ Revision: 1003099
- build VGA bioses too

* Sat Apr 16 2016 tv <tv> 1.9.1-1.mga6
+ Revision: 1003081
- new release
- update URL

* Sat Feb 20 2016 umeabot <umeabot> 1.7.5.2-3.mga6
+ Revision: 971848
- Mageia 6 Mass Rebuild

* Wed Oct 21 2015 danf <danf> 1.7.5.2-2.mga6
+ Revision: 893402
- Added noinline.patch to fix build on gcc 5.2

* Tue Feb 17 2015 alien <alien> 1.7.5.2-1.mga5
+ Revision: 815417
- Update to new version 1.7.5.2

* Wed Oct 15 2014 umeabot <umeabot> 0.6.2-6.mga5
+ Revision: 742766
- Second Mageia 5 Mass Rebuild

* Sun Jul 06 2014 ovitters <ovitters> 0.6.2-5.mga5
+ Revision: 648938
+ rebuild (emptylog)

* Fri Oct 18 2013 umeabot <umeabot> 0.6.2-5.mga4
+ Revision: 518337
- Mageia 4 Mass Rebuild

* Mon Jan 14 2013 umeabot <umeabot> 0.6.2-4.mga3
+ Revision: 381927
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Oct 27 2011 dmorgan <dmorgan> 0.6.2-3.mga2
+ Revision: 158643
- imported package seabios

